import { IMessagesRepository } from "@modules/messages/repositories/IMessagesRepository";
import { AppError } from "@shared/error/AppError";
import { injectable, inject } from "tsyringe";

@injectable()
class DeleteMessageUseCase {
    constructor(
        @inject('MessageRepository')
        private messagesRepository: IMessagesRepository
    ) { }

    async execute(id: string): Promise<void> {
        const forumDoesntExist = await this.messagesRepository.findById(id)
        if (!forumDoesntExist) {
            throw new AppError('Forum doesnt exists', 404);
        }

        await this.messagesRepository.delete(id)
    }
}

export { DeleteMessageUseCase }